#include "testlib.h"

const int MAXNS[] = {
        300,         // 0
        5,          // 1
        10,         // 2
        20,         // 3
        100,         // 4
        300          // 5
};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int gr = 0;
    if (!validator.group().empty()) {
        gr = atoi(validator.group().c_str());
    }

    int n = inf.readInt(1, MAXNS[gr], "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXNS[gr], "m");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        std::string s = inf.readToken("[A-Z]+", format("a[%d]", i + 1));
        ensuref(s.length() == m, "invalid length in line %d", i + 1);
        inf.readEoln();
    }

    inf.readEof();

    return 0;
}
