#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 5);
	int q = atoi(argv[1]);
	int d = atoi(argv[2]);
	int sz = atoi(argv[3]);
	int add_rem = atoi(argv[4]);

	vector<string> all;
	string cur = "";
	function<void(int)> rec = [&](int depth) {
		if (depth == d) {
			all.push_back(cur);
			return;
		}
		for (char c = 'a'; c <= 'z'; ++c) {
			cur += c;
			rec(depth + 1);
			if (szof(all) == sz) {
				return;
			}
			cur.pop_back();
		}
	};

	rec(0);

	set<int> have;
	set<int> not_have;
	vector<int> step(szof(all));
	int cnt = 0;
	vector<int> order(add_rem, 0);
	while (szof(order) < q) {
		order.push_back(2);
	}
	shuffle(order.begin() + szof(all), order.end());

	cout << q << "\n";

	for (int i = 0; i < q; ++i) {
		if (i < szof(all)) {
			cout << "+ " << all[i] << "\n";
			have.insert(i);
			step[i] = cnt++;
			continue;
		}
		if (order[i] == 2) {
			int ind;
			while (true) {
				ind = rnd.next(0, szof(all) - 1);
				if (have.count(ind)) {
					break;
				}
			}

			cout << "? " << step[ind] + 1 << "\n";
		} else {
			if (szof(have) < szof(all) && rnd.next() < 0.6) {
				int pos = rnd.next(0, szof(not_have) - 1);
				auto it = not_have.begin();
				for (int j = 0; j < pos; ++j) {
					++it;
				}
				int ind = *it;
				assert(!have.count(ind));
				not_have.erase(ind);
				have.insert(ind);
				cout << "+ " << all[ind]<< "\n";
				step[ind] = cnt++;
			} else {
				int ind;
				while (true) {
					ind = rnd.next(0, szof(all) - 1);
					if (have.count(ind)) {
						break;
					}
				}
				cout << "- " << step[ind] + 1 << "\n";
				have.erase(ind);
				not_have.insert(ind);
			}
		}
	}

	return 0;
}