#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int MAXQ = 100000;
int MAXS = 1000000;
int MAXL = 100000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	if (validator.group() == "1") {
		MAXQ = 50;
		MAXL = 15;
	} else if (validator.group() == "2") {
		MAXQ = 100;
		MAXL = 100;
	} else if (validator.group() == "3") {
		MAXQ = 3000;
		MAXL = 3000;
	}

	int q = inf.readInt(1, MAXQ, "q");
	inf.readEoln();
	set<string> have;
	vector<string> all;
	set<int> have_inds;
	int sum = 0;
	for (int i = 0; i < q; ++i) {
		string type = inf.readToken();
		inf.readSpace();
		ensure(type == "+" || type == "-" || type == "?");
		if (type == "+") {
			string s = inf.readToken("[a-z]{1, " + to_string(MAXL) + "}");
			sum += szof(s);
			all.push_back(s);
			ensuref(!have.count(s), "there can't be two equal names at the same time");
			have.insert(s);
			have_inds.insert(szof(all) - 1);
		} else if (type == "-") {
			int ind = inf.readInt(1, szof(all), "ind") - 1;
			ensuref(have_inds.count(ind), "file can't be removed twice");
			have_inds.erase(ind);
			have.erase(all[ind]);
		} else {
			int ind = inf.readInt(1, szof(all), "ind") - 1;
			ensuref(have_inds.count(ind), "file from question can't be removed before");
		}
		inf.readEoln();
	}

	inf.readEof();

	ensuref(sum <= MAXS, "total length of names shouldn't exceed %d (%d)", MAXS, sum);

	return 0;
}