#include "testlib.h"
#include <vector>
#include <algorithm>

const int maxn = 100000;
const int maxv = 1000000000;

const std::vector<int> MAXN = {4, 20, 10000, maxn};
const std::vector<int> MAXV = {11, 10000, 10000, maxv};

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());
    int n = inf.readInt(1, MAXN[group], "n");
    inf.readSpace();
    int a = inf.readInt(0, MAXV[group], "a");
    inf.readSpace();
    int b = inf.readInt(0, MAXV[group], "b");
    inf.readEoln();
    for (int i = 0; i < n; i++) {
      int x = inf.readInt(1, MAXV[group], format("num[%d]", i + 1));
      if (i + 1 < n) {
        inf.readSpace();
      } else {
        inf.readEoln();
      }
    }
    inf.readEof();
    return 0;
}
