#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>

using namespace std;

int ans;

void go(int n, int m, vector<string>& a, int x, int y, int diff) {
    if (x == n) {
        ans = min(ans, abs(diff));
        return;
    }
    if (clock() > 1.95 * CLOCKS_PER_SEC) {
        cout << ans << endl;
        exit(0);
    }
    for (int yy = y; yy <= m; yy++) {
        if (yy > y && x > 0) {
            if (a[x - 1][yy - 1] == a[x][yy - 1]) {
                break;
            }
        }
        if (yy == 0 || yy == m || a[x][yy - 1] != a[x][yy]) {
            go(n, m, a, x + 1, yy, diff + yy - (m - yy));
        }
    }
    for (int yy = y - 1; yy >= 0; yy--) {
        if (x > 0) {
            if (a[x - 1][yy] == a[x][yy]) {
                break;
            }
        }
        if (yy == 0 || yy == m || a[x][yy - 1] != a[x][yy]) {
            go(n, m, a, x + 1, yy, diff + yy - (m - yy));
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;
    ans = n * m;
    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    go(n, m, a, 0, 0, 0);
    cout << ans << endl;

    return 0;
}
