#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 4);

	int q = atoi(argv[1]);
	int maxl = atoi(argv[2]);
	char maxc = argv[3][0];

	int tot_amount = 0;
	for (int l = 1; l <= maxl; ++l) {
		ll cur = 1;
		for (int i = 0; i < l; ++i) {
			cur = min(cur * (maxc - 'a' + 1), (ll) INF);
		}
		tot_amount = min(tot_amount + (int) cur, INF);
	}

	set<int> have;
	set<string> have_names;
	int cnt = 0;
	vector<string> all;

	function<string()> choose_name = [&]() {
		while (true) {
			string cur = "";
			int l = rnd.next(1, maxl);
			for (int i = 0; i < l; ++i) {
				cur += rnd.next('a', maxc);
			}
			if (!have_names.count(cur)) {
				return cur;
			}
		}
	};

	cout << q << "\n";

	for (int req = 0; req < q; ++req) {
		int type;
		while (true) {
			type = rnd.next(0, 2);
			if (szof(have_names) == tot_amount && type == 0) {
				continue;
			}
			if (type != 0 && szof(have) == 0) {
				continue;
			}
			break;
		}
		if (type == 0) {
			string name = choose_name();
			cout << "+ " << name << "\n";
			have.insert(cnt);
			have_names.insert(name);
			all.push_back(name);

			++cnt;
		} else if (type == 1) {
			int pos = rnd.next(0, szof(have) - 1);
			auto it = have.begin();
			for (int i = 0; i < pos; ++i) {
				++it;
			}
			int ind = *it;
			cout << "- " << ind + 1 << "\n";
			have.erase(ind);
			have_names.erase(all[ind]);
		} else {
			int pos = rnd.next(0, szof(have) - 1);
			auto it = have.begin();
			for (int i = 0; i < pos; ++i) {
				++it;
			}
			int ind = *it;
			cout << "? " << ind + 1 << "\n";
		}
	}

	return 0;
}