#include <bits/stdc++.h>
#include "testlib.h"

const int MAXN = 100;

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int a = inf.readInt();
    int b = inf.readInt();
    
    std::vector<int> num(n);
    for (int i = 0; i < n; i++) {
        num[i] = inf.readInt();
    }
    
    auto check_answer = [&](auto& stream) {
        int ans = stream.readInt(-1, MAXN);
        if (ans == -1) {
            return ans;
        }
        int cur = a;
        for (int i = 0; i < ans; ++i) {
            int ind = stream.readInt(1, n) - 1;
            cur |= num[ind];
        }
        if (cur != b) {
            stream.quitf(_wa, "After applying of opperations, result isn't equal to B");
        }
        return ans;
    };
    int pn = check_answer(ouf);
    int jn = check_answer(ans);
    if (pn == -1 && jn == -1) {
        quitf(_ok, "No solution");
    }
    if (pn == -1) {
        quitf(_wa, "Jury has found solution, but participant didn't");
    }
    if (jn == -1) {
        quitf(_fail, "Jury didn't find solution, but participant did");
    }
    quitf(_ok, format("Correct, n = %d", pn).c_str());
    return 0;
}
